<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Tabel Note</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-uWxY/CJNBR+1zjPWmfnSnVxwRheevXITnMqoEIeG1LJrdI0GlVs/9cVSyPYXdcSF" crossorigin="anonymous">
  </head>
  <header>
    <nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark">
      <div class="container-fluid">
        <a class="navbar-brand" href="#">MyNotes</a>
        <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarCollapse" aria-controls="navbarCollapse" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="navbarCollapse">
          <ul class="navbar-nav me-auto mb-2 mb-md-0">
            <li class="nav-item">
              <a class="nav-link active" aria-current="page" href="/lab-4/add-note">Add Note</a>
            </li>
            <li class="nav-item">
              <a  class="nav-link active" aria-current="page" href="/lab-5/">All Notes</a>
            </li>
            <li class="nav-item">
              <a class="nav-link active" aria-current="page" href="/lab-4/note-list">List Notes</a>
            </li>
          </ul>
        </div>
      </div>
    </nav>
  </header>
  <body>
    {% load static %}
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ka7Sk0Gln4gmtz2MlQnikT1wXgYsOg+OMhuP+IlRH9sENBO0LRn5q+8nbTov4+1p" crossorigin="anonymous"></script>
    <script>
      $(document).ready(function(){

        TableValue()

        console.log("ini masuk loh")

        function TableValue() {
          setTimeout(function(){
          $.ajax({
            url: "http://127.0.0.1:8000/lab-4/json", 
            dataType: 'json',
            success: function(hasil){
              for(i=0; i < hasil.length; i++){
                var tempB = "<button type='button' id='"+hasil[i].pk+"' class='view btn btn-primary'>View</button><button type='button' id='"+hasil[i].pk+"' class='show-edit-modal btn btn-success'>Edit</button><button type='button' id='"+hasil[i].pk+"' class='deleteWarn btn btn-danger'>Delete</button>"
                var temp = "<tr><td scope='row col-2'>"+hasil[i].fields.to+"</td><td class='col-2'>"+hasil[i].fields.from_m+"</td><td class='col-2'>"+hasil[i].fields.title+"</td><td>"+hasil[i].fields.message+"</td><td class='col-1'>"+tempB+"</td></tr>"
                $("#tr_note").append(temp);
              }
          }})
        },500);}

      $('#tr_note').on("click",'.view',function(){
        console.log("ini view")
        var id = $(this).attr('id');
          $.ajax({
          url: 'http://127.0.0.1:8000/lab-5/notes/'+id, 
          dataType: 'json',
          success: function(hasil){
            var temp1 = "<div class='modal-header'><h4 class='modal-title d-flex justify-content-center'>"+hasil[0].fields.title+"</h4><h5 class='modal-title'>To: "+hasil[0].fields.to+"</h5><br><h5 class='modal-title'>From: "+hasil[0].fields.from_m+"</h5><br><button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button></div><div class='modal-body'><p>"+hasil[0].fields.message+"</p></div><div class='modal-footer'><button type='button' class='btn btn-secondary' data-bs-dismiss='modal'>Close</button></div>";
            $('body').append("<div id='modal-view' class='modal' tabindex='-1'><div class='modal-dialog modal-dialog-centered modal-dialog-scrollable'><div class='modal-content'>"+temp1+"</div></div></div>");
            $('#modal-view').modal('show');
          }})
      });

      let pk = "";
      $('#tr_note').on("click",'.show-edit-modal',function(){
        console.log("ini edit");
        pk = $(this).attr('id');
        $('#modal-edit').modal('show');
      });

      $("#form-update").submit(function(e) {
        e.preventDefault();

      $.ajax({
        type: 'POST',
        url: '/lab-5/notes/'+pk+'/update',
        dataType: 'json',
        data: {
          'title': $("#input-from").val(),
          'to': $("#input-to").val(),
          'from_m': $("#input-title").val(),
          'message': $("#input-message").val(),
          'csrfmiddlewaretoken': $("input[name=csrfmiddlewaretoken]").val(),
        },
        success: function (response) {
          $("#input-from").val("") 
          $("#input-to").val("") 
          $("#input-title").val("") 
          $("#input-message").val("")

          $("#tr_note").empty();
          TableValue()
        }})
      });

      $('#modal-delete').on("click",'.delete',function(){
        var id = $(this).attr('id');
          $.ajax({
          url: 'http://127.0.0.1:8000/lab-5/notes/'+id+'/delete', 
          type: 'POST',
          data: {'csrfmiddlewaretoken': $("input[name=csrfmiddlewaretoken]").val()},
          dataType: "json",
          success: function(hasil){
          }})
      });

        $('#tr_note').on("click",'.deleteWarn',function(){
          var id = $(this).attr('id');
            $.ajax({
            url: 'http://127.0.0.1:8000/lab-5/notes/'+id, 
            data: {'csrfmiddlewaretoken': $("input[name=csrfmiddlewaretoken]").val()},
            dataType: 'json',
            success: function(hasil){
              $('.delete').remove();
              $('#div-input-delete').append("<input id='"+hasil[0].pk+"' class='delete btn btn-danger' type='submit' Value='Hapus'>")
              $('#modal-delete').modal('show');
            }})
        });
    });
    </script>
    <br>
    <h3 class="mt-5 text-center">All Note</h3>
    <br>
    <div class="container">
      <table class="table table-secondary table-striped">
        <thead>
          <tr>
            <th scope="col col-2">To</th>
            <th scope="col col-2">From</th>
            <th scope="col col-2">Title</th>
            <th scope="col">Message</th>
            <th scope="col col-1">Actions</th>
          </tr>
        </thead>
        <tbody id = "tr_note">

        </tbody>  
      </table>
    </div>

    <div id='modal-edit' class='modal' tabindex='-1'>
      <div class='modal-dialog modal-dialog-centered'>
        <div class='modal-content'>"
          <div class='modal-header'>
            <h5 class="modal-title" id="exampleModalLabel">Edit</h5>
            <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
          </div>
          <form action='' method = 'POST' id = "form-update">
            {% csrf_token %}
            <div class='modal-body'>
              <div class="container">
                <div class="ms-2 row g-3 me-2">
                  <div class="col-md-6">
                  <h6><label class="form-label">To</label></h6>
                    <input type="text" id = 'input-to' class="form-control" name="to" placeholder="To" maxlength="30">
                  </div>
                  <div class="col-md-6">
                    <h6><label class="form-label">From</label></h6>
                    <input type="text" id = 'input-from' class="form-control" name="from_m" placeholder="From" maxlength="30">
                  </div>
                </div>
                <br>
                <div class="ms-3 col-11,5 me-3">
                  <label class="form-label">Title</label>
                  <input type="text" id = 'input-title' class="form-control" name="title" placeholder="Enter Title Here" maxlength="30">
                </div>
                <br>
                <div class="ms-3 col-11,5 me-3">
                  <label class="form-label">Message</label>
                  <input type="text" id = 'input-message' class="form-control" name="message" placeholder="Message">
                </div>
              </div>
            </div>
            <div id='div-input' class='modal-footer'>
              <button type='submit' class='btn btn-primary' data-bs-dismiss='modal'>Update</button>
            </div>
          </form>
        </div>
      </div>
    </div>

    <div id='modal-delete' class='modal' tabindex='-1'>
      <div class='modal-dialog modal-dialog-centered'>
        <div class='modal-content'>"
          <div class='modal-header'>
            <h4 class='modal-title'>Warning</h4>
            <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
          </div>
          <div class='modal-body'>
            <p>Apakah anda yakin akan menghapus ini?</p>
          </div>
          <form action='' method = 'POST'>
            {% csrf_token %}
            <div id='div-input-delete' class='modal-footer'>
              <button type='button' class='btn btn-primary' data-bs-dismiss='modal'>Batal</button>
            </div>
          </form>
        </div>
      </div>
    </div>

    <div id='modal-delete-confirm' class='modal' tabindex='-1'>
      <div class='modal-dialog modal-dialog-centered'>
        <div class='modal-content'>
          <div class='modal-header'>
            <h4 class='modal-title d-flex justify-content-center'>Success</h4>
            <button type='button' class='btn-close' data-bs-dismiss='modal' aria-label='Close'></button>
          </div>
          <div class='modal-body'>
            <p>Data dengan berhasil dihapus</p>
          </div>
          <div class='modal-footer'>
            <button type='button' class='btn btn-secondary'>Close</button>
          </div>
        </div>
      </div>
    </div>
  </div>
  
  </body>
  
</html>

